#!/usr/bin/python3
# -*- coding: utf-8 -*-

   #################################
   #                               #
   #   Equation de la chaleur 2D   #
   #                               #
   #################################

import time
import numpy as np
import matplotlib.pyplot as plt

## INITIALISATION ##
xxx=0

# dimensions du domaine
Lx, Ly = 1., 1.

# nombre de points
NbX, NbY = 51, 51

# pas de discretisation
dx, dy = Lx / (NbX-1), Ly / (NbY-1)

# grille du domaine
X = np.linspace(0,Lx,NbX)
Y = xxx

# conditions aux bords
Tg, Td = 50., 0.
Tb, Th = 100., 00.

# constantes du schéma (1/4 si dx=dy)
a = xxx
b = xxx

# constantes d'arret
MinEVolution = 0.01
MaxIteration = 2*10**3

## PROGRAMME PRINCIPAL ##
t = time.time()

# initialisation des matrices Temperature (à k et k-1)
T = np.zeros((NbX,NbY)) # matrice de temperature a l'instant tk
for i in range(xxx):
   T[i,0] = xxx
   xxx
for j in range(xxx):
   xxx
   T[-1,j] = xxx
TT = xxx   # matrice de temperature a l'instant tk-1

# programme principal
k = 0
MaxEvol = 1.
while xxx and k < MaxIteration : # test : evolution et nb iteration
   MaxEvol = xxx
   for i in range(xxx):
      for j in range(xxx):
         xxx
         xxx
   TT = np.copy(T)
   xxx

t = xxx
print("Nb iterations : %1.0f," %k, "Evolution : %1.4f," %MaxEvol, "temps : %1.4f" %t)

plt.figure()
plt.pcolormesh(X, Y, np.transpose(T), shading='flat')
plt.colorbar()
plt.axis('image')
plt.show()

# fin du fichier EquationChaleur2D-eleve.py
